diff --git a/src/dynamic_compiler.c b/src/dynamic_compiler.c
index aa9cc756ce..54ddb4fd10 100644
--- a/src/dynamic_compiler.c
+++ b/src/dynamic_compiler.c
@@ -181,6 +181,7 @@ DONE #define MGF_BASE_16_OUTPUT_UPCASE    0x00002000
 #include "memdbg.h"
 
 static int gost_init = 0;
+const char *options_format;
 
 typedef struct DC_list {
 	struct DC_list *next;
@@ -1607,6 +1608,10 @@ char *dynamic_compile_prepare(char *fld0, char *fld1) {
 	}
 	else if (!strncmp(fld1, "@dynamic=", 9))
 		fld1 = dynamic_expr_normalize(fld1);
+	else if (strstr(options_format, "$u") && fld0 && *fld0 && !strstr(fld1, "$$U")) {
+		snprintf(Buf, sizeof(Buf), "%s$$U%s", fld1, fld0);
+		fld1 = dynamic_expr_normalize(Buf);
+	}
 	return fld1;
 }
 char *dynamic_compile_split(char *ct) {
diff --git a/src/dynamic_compiler_fmt_plug.c b/src/dynamic_compiler_fmt_plug.c
index bb682e4af7..78fa827b9c 100644
--- a/src/dynamic_compiler_fmt_plug.c
+++ b/src/dynamic_compiler_fmt_plug.c
@@ -34,6 +34,7 @@ john_register_one(&fmt_CompiledDynamic);
 #include "dynamic.h"
 #include "dynamic_compiler.h"
 #include "dynamic_types.h"
+#include "options.h"
 #include "memdbg.h"
 
 #define FORMAT_LABEL		"dynamic="
@@ -99,8 +100,14 @@ static char *our_split(char *ciphertext, int index, struct fmt_main *self)
 }
 static char *our_prepare(char **fields, struct fmt_main *self)
 {
-	char *ciphertext = dynamic_compile_prepare(fields[0], fields[1]);
-	return ciphertext;
+	if (options.format && !strncmp(options.format, "dynamic=", 8)) {
+		extern const char *options_format;
+		char *ct;
+		options_format = options.format;
+		ct = dynamic_compile_prepare(fields[0], fields[1]);
+		return ct;
+	}
+	return fields[1];
 }
 
 static int our_valid(char *ciphertext, struct fmt_main *self)
